resource_name 'replace'
actions :run
default_action :run

property :name, :name_property => true, :kind_of => String, :required => true
property :path, :kind_of => String
property :replace, :kind_of => [String, Regexp], :required => true
property :with, :kind_of => String, :required => true

action :run do

	file_path = path || name

	# Check if we got a regex or a string
	if replace.is_a?(Regexp)
		regex = replace
	else
		regex = Regexp.new(Regexp.escape(replace))
	end

	# Check if file matches the regex
	if ::File.read(file_path) =~ regex

		# Replace the matching text
		converge_by("Replace #{name}") do
			ruby_block "#{name}" do
				block do
					file = Chef::Util::FileEdit.new(file_path)
					file.search_file_replace(regex, with)
					file.write_file
				end
			end
		end

		Chef::Log.info "- #{replace}"
		Chef::Log.info "+ #{with}"

		# Notify that a node was updated successfully
		updated_by_last_action(true)

	end
end
